unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function ImagesIntersect(IImage1,IImage2:TImage):boolean;
{ uses ExtCtrls }
var region_prve,region_druge,nepotrebni_rect:TRect;
begin
//kreiramo nevidljive pravougaonike preko slika
region_prve:=Rect(IImage1.Left, IImage1.Top, IImage1.Left+IImage1.Width, IImage1.Top+IImage1.Height);
region_druge:=Rect(IImage2.Left, IImage2.Top, IImage2.Left+IImage2.Width, IImage2.Top+IImage2.Height);
//funkcijom za gledanje da li se rect-ovi preklapaju, vracamo rezultat
Result:=IntersectRect(nepotrebni_rect,region_prve,region_druge);
//by Avram, avramyu ATAT gmail DOTDOT com
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//kontrolisemo prvu zabu
if Key = VK_UP then Image1.Top:=Image1.Top-3;
if Key = VK_DOWN then Image1.Top:=Image1.Top+3;
if Key = VK_LEFT then Image1.Left:=Image1.Left-3;
if Key = VK_RIGHT then Image1.Left:=Image1.Left+3;
//kontrolisemo drugu zabu
if Key = Ord('W') then Image2.Top:=Image2.Top-3;
if Key = Ord('S') then Image2.Top:=Image2.Top+3;
if Key = Ord('A') then Image2.Left:=Image2.Left-3;
if Key = Ord('D') then Image2.Left:=Image2.Left+3;
//detektujemo sudare novom funkcijom
if ImagesIntersect(Image1,Image2) then Label2.Caption := 'Preklapanje: DA'
  else Label2.Caption := 'Preklapanje: NE';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
DoubleBuffered:=true; //izbegavamo treperenje
end;

end.
